<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" creationComplete="creationCompleteHandler(event)" title="Pesquisa de Tipo Documento Movimento Estoque" xmlns:visual="br.com.desenv.framework.component.visual.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="TipoDocumentoMovimentoEstoqueSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.controls.DateField;
			import mx.validators.Validator;
			
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.TipoDocumentoMovimentoEstoque;

			
			[Bindable]
			public var listaTipoDocumentoMovimentoEstoque: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			

			
			private var tipoDocumentoMovimentoEstoqueComponenteDetalhe: TipoDocumentoMovimentoEstoqueComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): TipoDocumentoMovimentoEstoque
			{
				var tipoDocumentoMovimentoEstoqueFiltro: TipoDocumentoMovimentoEstoque = new TipoDocumentoMovimentoEstoque();
				
				tipoDocumentoMovimentoEstoqueFiltro.descricao = ignTextInputDescricaoPesquisa.text == ""?null:"%" + ignTextInputDescricaoPesquisa.text + "%";
				tipoDocumentoMovimentoEstoqueFiltro.ativo = ignComboBoxFixoAtivoPesquisa.selectedItem == null?null:ignComboBoxFixoAtivoPesquisa.selectedItem.codigo == ""?null:ignComboBoxFixoAtivoPesquisa.selectedItem.codigo; 
				tipoDocumentoMovimentoEstoqueFiltro.atualizaPreco = ignComboBoxFixoAtualizaPrecoPesquisa.selectedItem == null?null:ignComboBoxFixoAtualizaPrecoPesquisa.selectedItem.codigo == ""?null:ignComboBoxFixoAtualizaPrecoPesquisa.selectedItem.codigo; 
				tipoDocumentoMovimentoEstoqueFiltro.entradaSaida = ignComboBoxFixoEntradaSaidaPesquisa.selectedItem == null?null:ignComboBoxFixoEntradaSaidaPesquisa.selectedItem.codigo == ""?null:ignComboBoxFixoEntradaSaidaPesquisa.selectedItem.codigo; 
				return tipoDocumentoMovimentoEstoqueFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectTipoDocumentoMovimentoEstoque: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoDocumentoMovimentoEstoqueService", listarResultHandler);	
				
				
				var tipoDocumentoMovimentoEstoqueFiltro: TipoDocumentoMovimentoEstoque = new TipoDocumentoMovimentoEstoque();
				remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, tipoDocumentoMovimentoEstoqueFiltro); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaTipoDocumentoMovimentoEstoque: Page = event.result as Page;
				pageNumber = paginaTipoDocumentoMovimentoEstoque.pageNumber;
				totalRecords = paginaTipoDocumentoMovimentoEstoque.totalRecords;
				lastPage = paginaTipoDocumentoMovimentoEstoque.lastPage();
				listaTipoDocumentoMovimentoEstoque = paginaTipoDocumentoMovimentoEstoque.recordList;
				labelPaginaAtual.text = "" + paginaTipoDocumentoMovimentoEstoque.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaTipoDocumentoMovimentoEstoque.totalRecords;
			}

// CARREGANDO COMBOS			

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectTipoDocumentoMovimentoEstoque: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoDocumentoMovimentoEstoqueService", listarResultHandler);	
					remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var tipoDocumentoMovimentoEstoqueComponenteCadastro: TipoDocumentoMovimentoEstoqueComponenteCadastro = new TipoDocumentoMovimentoEstoqueComponenteCadastro();
				tipoDocumentoMovimentoEstoqueComponenteCadastro.tipoDocumentoMovimentoEstoque = new TipoDocumentoMovimentoEstoque(); 
				tipoDocumentoMovimentoEstoqueComponenteCadastro.addEventListener("TipoDocumentoMovimentoEstoqueIncluidoEvent", atualizarListaTipoDocumentoMovimentoEstoquePorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(tipoDocumentoMovimentoEstoqueComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(tipoDocumentoMovimentoEstoqueComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var tipoDocumentoMovimentoEstoqueSelecionado: TipoDocumentoMovimentoEstoque = datagridListaTipoDocumentoMovimentoEstoque.selectedItem as TipoDocumentoMovimentoEstoque;
				this.dispatchEvent(new ResultEvent("TipoDocumentoMovimentoEstoqueSelecionadoEvent",false, true, tipoDocumentoMovimentoEstoqueSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaTipoDocumentoMovimentoEstoque_doubleClickHandler(event:MouseEvent):void
			{
				tipoDocumentoMovimentoEstoqueComponenteDetalhe = new TipoDocumentoMovimentoEstoqueComponenteDetalhe();
				tipoDocumentoMovimentoEstoqueComponenteDetalhe.tipoDocumentoMovimentoEstoque = datagridListaTipoDocumentoMovimentoEstoque.selectedItem as TipoDocumentoMovimentoEstoque;
				tipoDocumentoMovimentoEstoqueComponenteDetalhe.addEventListener("TipoDocumentoMovimentoEstoqueExcluidoEvent", atualizarListaTipoDocumentoMovimentoEstoquePorExclusaoResultHandler);
				tipoDocumentoMovimentoEstoqueComponenteDetalhe.addEventListener("TipoDocumentoMovimentoEstoqueAtualizadoEvent", atualizarListaTipoDocumentoMovimentoEstoquePorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(tipoDocumentoMovimentoEstoqueComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(tipoDocumentoMovimentoEstoqueComponenteDetalhe);
			}
			
			
			private function atualizarListaTipoDocumentoMovimentoEstoquePorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectTipoDocumentoMovimentoEstoque: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoDocumentoMovimentoEstoqueService", listarResultHandler);	
				remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaTipoDocumentoMovimentoEstoquePorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectTipoDocumentoMovimentoEstoque: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoDocumentoMovimentoEstoqueService", listarResultHandler);	
				remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaTipoDocumentoMovimentoEstoquePorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectTipoDocumentoMovimentoEstoque: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoDocumentoMovimentoEstoqueService", listarResultHandler);	
				remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectTipoDocumentoMovimentoEstoque: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoDocumentoMovimentoEstoqueService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectTipoDocumentoMovimentoEstoque: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoDocumentoMovimentoEstoqueService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectTipoDocumentoMovimentoEstoque: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoDocumentoMovimentoEstoqueService", listarResultHandler);	
				remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectTipoDocumentoMovimentoEstoque: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoDocumentoMovimentoEstoqueService", listarResultHandler);	
				remoteObjectTipoDocumentoMovimentoEstoque.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<s:ArrayCollection id="listaOpcaoAtivo">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="SIM"/>
			<fx:Object codigo="N" valor="NAO"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoAtualizaPreco">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="SIM"/>
			<fx:Object codigo="N" valor="NAO"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoEntradaSaida">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="E" valor="ENTRADA"/>
			<fx:Object codigo="S" valor="SAÍDA"/>
		</s:ArrayCollection>
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Tipo Documento Movimento Estoque:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricaoPesquisa" styleName="labelValidacao" text="{ignTextInputDescricaoPesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricaoPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Ativo:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoAtivoPesquisa" styleName="labelValidacao" text="{ignComboBoxFixoAtivoPesquisa.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoAtivoPesquisa" obrigatorio="false" dataProvider="{listaOpcaoAtivo}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>


		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Atualizar Preço:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoAtualizaPrecoPesquisa" styleName="labelValidacao" text="{ignComboBoxFixoAtualizaPrecoPesquisa.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoAtualizaPrecoPesquisa" obrigatorio="false" dataProvider="{listaOpcaoAtualizaPreco}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Entrada/Saída:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoEntradaSaidaPesquisa" styleName="labelValidacao" text="{ignComboBoxFixoEntradaSaidaPesquisa.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoEntradaSaidaPesquisa" obrigatorio="false" dataProvider="{listaOpcaoEntradaSaida}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>



		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaTipoDocumentoMovimentoEstoque"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaTipoDocumentoMovimentoEstoque}" doubleClick="datagridListaTipoDocumentoMovimentoEstoque_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="descricao" headerText="Tipo Documento Movimento Estoque" resizable="true"/>
						<mx:DataGridColumn dataField="ativoDescricaoCompleta" headerText="Ativo" resizable="true"/>
						<mx:DataGridColumn dataField="atualizaPrecoDescricaoCompleta" headerText="Atualizar Preço" resizable="true"/>
						<mx:DataGridColumn dataField="entradaSaidaDescricaoCompleta" headerText="Entrada/Saída" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
